#include "ExampleClass.hpp"



Example::Example(int N_in, float *pA, float *pB){

	N = N_in;
	cudaMalloc(&d_A, N*sizeof(float));
	cudaMalloc(&d_B, N*sizeof(float));
	cudaMalloc(&d_C, N*sizeof(float));
	CudaError("Malloc");

	cudaMemcpy(d_A, pA, N*sizeof(float), cudaMemcpyHostToDevice);
	cudaMemcpy(d_B, pB, N*sizeof(float), cudaMemcpyHostToDevice);
	CudaError("Memcpy");

};

void Example::add(){

	dim3 dimBlock((unsigned int)N);
	dim3 dimGrid(1);
	
	//kernel calls
	kernel_add_wrapper(dimGrid, dimBlock, d_A, d_B,d_C);
	CudaError("kernel_add_wrapper");
};
  
//*******************************************************************************************
void Example::CudaError(const char * InStr) {
	/*!
	*  \brief A simple function to dump Cuda errors and abort the run.
	*/
	cudaError_t errornum;
	const char *str = 0;
	if (errornum = cudaGetLastError()) {
		str = cudaGetErrorString(errornum);
		mexErrMsgIdAndTxt("CudaTemplate:CUDA", "%s: %s\nYou should clear this function in MATLAB for proper operation.\n", InStr, str);
	}
}