/*!
 * \file wrapper.cu
 * \author 
 * \date April 20, 2012
 * \brief Wrap the Cuda kernel calls as standard external C functions.  This allows the kernels to be
 * called without doing anything special in the C code and simplifies building the code.
 */

#include "definitions.h"
#include "kernel.h"

//*******************************************************************************************
extern "C" void kernel_add_wrapper(dim3 dimGrid, dim3 dimBlock, float * A, float *B, float *C)
{
	/*! 
	 * \brief Example kernel to test build settings.
	 */
	kernel_add<<<dimGrid,dimBlock>>>(A,B,C);
	cudaDeviceSynchronize();
}